<?php


namespace Ardent\PicnicApi\Objects;


class Delivery extends AbstractApiObject
{
    /**
     * Delivery constructor.
     */
    public function __construct(
        private string $id,
        private string $deliveryId,
        private string $creationTime,
        private array  $slot,
        private array  $eta2,
        private string $status,
        private array  $deliveryTime,
        private array  $orders,
    )
    {
    }

    static public function getType(): string
    {
        return 'DELIVERY';
    }

    static public function fromApi(array $apiObject): AbstractApiObject
    {
        return new self(
            $apiObject['id'],
            $apiObject['delivery_id'],
            $apiObject['creation_time'],
            $apiObject['slot'],
            $apiObject['eta2'],
            $apiObject['status'],
            $apiObject['delivery_time'] ?? [],
            ApiListTransformer::getObjects($apiObject['orders']),
        );
    }

    /**
     * @return string
     */
    public function getId(): string
    {
        return $this->id;
    }

    /**
     * @return string
     */
    public function getDeliveryId(): string
    {
        return $this->deliveryId;
    }

    /**
     * @return string
     */
    public function getCreationTime(): string
    {
        return $this->creationTime;
    }

    /**
     * @return array
     */
    public function getSlot(): array
    {
        return $this->slot;
    }

    /**
     * @return array
     */
    public function getEta2(): array
    {
        return $this->eta2;
    }

    /**
     * @return string
     */
    public function getStatus(): string
    {
        return $this->status;
    }

    /**
     * @return array
     */
    public function getDeliveryTime(): array
    {
        return $this->deliveryTime;
    }

    /**
     * @return Order[]
     */
    public function getOrders(): array
    {
        return $this->orders;
    }
}