<?php


namespace Ardent\PicnicApi\Objects;


class OrderLine extends AbstractApiObject
{
    /**
     * OrderLine constructor.
     */
    public function __construct(
        private string $id,
        private array  $items,
        private int    $displayPrice,
        private int    $price,
    )
    {
    }

    static public function getType(): string
    {
        return 'ORDER_LINE';
    }

    static public function fromApi(array $apiObject): AbstractApiObject
    {
//        dump($apiObject);
        return new self(
            $apiObject['id'],
            ApiListTransformer::getObjects($apiObject['items']),
            $apiObject['display_price'],
            $apiObject['price'],
        );
    }

    public function getId(): string
    {
        return $this->id;
    }

    /**
     * @return OrderArticle[]
     */
    public function getItems(): array
    {
        return $this->items;
    }

    public function getDisplayPrice(): float
    {
        return $this->displayPrice / 100.0;
    }

    public function getPrice(): float
    {
        return $this->price / 100.0;
    }

    public function getCount(): int
    {
        return count($this->items);
    }
}